'use strict';

exports.__esModule = true;
exports.receivePage = exports.requestPage = undefined;

var _actionTypes = require('./actionTypes');

var requestPage = exports.requestPage = function requestPage(endpoint, name, initialItem, resultsKey, countKey, pageArgName, idKey, page, params) {
  return {
    type: _actionTypes.REQUEST_PAGE,
    meta: {
      endpoint: endpoint,
      name: name,
      initialItem: initialItem,
      resultsKey: resultsKey,
      countKey: countKey,
      pageArgName: pageArgName,
      idKey: idKey
    },
    payload: {
      page: page,
      params: params
    }
  };
};

var receivePage = exports.receivePage = function receivePage(endpoint, name, initialItem, pageArgName, idKey, page, params, items, count) {
  var fromCache = arguments.length <= 9 || arguments[9] === undefined ? false : arguments[9];
  return {
    type: _actionTypes.RECEIVE_PAGE,
    meta: {
      endpoint: endpoint,
      name: name,
      initialItem: initialItem,
      pageArgName: pageArgName,
      idKey: idKey,
      fromCache: fromCache
    },
    payload: {
      page: page,
      params: params,
      items: items,
      count: count
    }
  };
};